/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package netz.model;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.logging.Level;
import java.util.logging.Logger;
import ohmlogger.OhmLogger;

/**
 *
 * @author chris
 */
public class ClientRunnable implements Runnable
{
  private static Logger lg = OhmLogger.getLogger();
  private String ip_adresse;
  private int port;
  private ExecutorService eService;
  
  public ClientRunnable(String IP_ADRESSE, int PORT) throws IOException
  {
    this.ip_adresse = IP_ADRESSE;
    this.port = PORT;
    
    eService = Executors.newSingleThreadExecutor();
    
    this.start();
  
  }
  
  public synchronized void start()
  {
    eService.submit(this);
    this.notifyAll();
    lg.info("Thread startet");
  }

  @Override
  public void run()
  {
    try
    {
      lg.info("Client: verbinde ...");
      Socket s = new Socket(ip_adresse, port); // Achtung: blockiert!
      lg.info("Client: Verbindung hergestellt");
      InputStream iStream = s.getInputStream();
      OutputStream oStream = s.getOutputStream();

      InputStreamReader isr = new InputStreamReader(iStream, "UTF-8");
      OutputStreamWriter osr = new OutputStreamWriter(oStream, "UTF-8");

      BufferedReader in = new BufferedReader(isr);
      //BufferedWriter out = new BufferedWriter(osr);
      PrintWriter out = new PrintWriter(osr);

      lg.info("Client: Stream initialisiert");

      out.println("Hallo Du Server Du - ich bin der client");
      out.flush(); // wirklich absenden!!

      lg.info("Client: Nachricht versendet");

      String quittung = in.readLine(); // Achtung blockiert
      lg.info("Client: Quittung empfangen");

      System.out.println("Client: Quittung EMPFANGEN - " + quittung);

      out.close();
      in.close();
      
    }
    catch (Exception ex)
    {
      Logger.getLogger(ServerRunnable.class.getName()).log(Level.SEVERE, null, ex);
    }
  

    
  }
}
